/* NOTE: THIS VERSION OF THE SCORE WORKS BECAUSE WE HANDLE THE OVERLAPPING TIMES BY
   USING SEPARATE AUX BUSSES FOR EACH EVENT (AN OK SOLUTION, BUT DOES NOT SCALE WELL
   FOR LARGE NUMBERS OF OVERLAPPING EVENTS)
*/

rtsetparams(48000, 2);

rtinput("/Users/dscott/CLASSNEW/Willard-July27-1955.wav");	// read audio from this file

load("TRANS");	// these let me run the score from the command line
load("MOOGVCF");

// TRANS reads from the input sound file and outputs into one aux bus.

bus_config("TRANS", "in 0", "aux 0 out");

// Have MOOGVCF read from that aux bus and send to a pair of output busses.

bus_config("MOOGVCF", "aux 0 in", "out 0-1");

// Creating variables for all your instrument's arguments makes it easy to
// remember them.

///////////////////////////////////////////////////////////
////////////////////// FIRST EVENT ///////////////////////
// Starts at output time 0.  Duration 5 seconds.  Transpose down 1/2 octave.
// Filter at 1000 Hz.
///////////////////////////////////////////////////////////

// TRANS arguments

start = 67;		// where TRANS will read from the input audio file
outskip = 0;	// where TRANS will write into the aux bus
duration = 5;
gain = 1;		// the input file's samples are already in the +-32K range
envelope = maketable("line", 1000, 0,0, 1,1, 9,1, 10,0);
transp_interval = -0.06;	// transpose down 1/2 octave

// transpose it!
TRANS(outskip, start, duration, gain*envelope, transp_interval);

// MOOGVCF arguments

outskip = 0;	// because MOOGVCF writes to output, this is our real outskip
start = 0;		// the instrument must always read from the start of the aux buffer
moog_gain = 50;		// using this gain to adjust for MOOGVCF effect
cutoff_freq = 1000;
resonance = 0.9;
pan = 1;			// hard left

// filter the result of that transpose!
MOOGVCF(outskip, start, duration, moog_gain, inchan=0, pan, bypass=0, cutoff_freq, resonance);

///////////////////////////////////////////////////////////
////////////////////// SECOND EVENT ///////////////////////
// Starts at output time 2.  Duration 4 seconds.  Transpose up 1 octave.
// Filter at 400 Hz.  Different gain envelope.
///////////////////////////////////////////////////////////

// THIS CALL TO TRANS reads from the input sound file and outputs into a DIFFERENT aux bus.

bus_config("TRANS", "in 0", "aux 1 out");

// MOOGVCF reads from THAT DIFFERENT aux bus and send to a pair of output busses.

bus_config("MOOGVCF", "aux 1 in", "out 0-1");

// TRANS arguments

start = 203;		// where TRANS will read from the input audio file
outskip = 0;		// where TRANS will write into ITS aux bus
duration = 4;
gain = 1;		// the input file's samples are already in the +-32K range
envelope = maketable("line", 1000, 0,0, 1,1, 2,0);
transp_interval = 1.00;	// transpose up 1 octave

// transpose it!
TRANS(outskip, start, duration, gain*envelope, transp_interval);

// MOOGVCF arguments

outskip = 2;		// because MOOGVCF writes to output, this is our real outskip
start = 0;			// the instrument must always read from the start of the aux buffer
moog_gain = 400;	// using this gain to adjust for MOOGVCF effect
cutoff_freq = 400;
resonance = 0.9;
pan = 0;			// hard right


// filter the result of that transpose!
MOOGVCF(outskip, start, duration, moog_gain, inchan=0, pan, bypass=0, cutoff_freq, resonance);
